<?php
class PRViews{
	
	public function PRViews(){
	
	}
	
	/**
	 * displays the Add New Form
	 * @params bool $success true if the data is submitted and the data was saved successfully
	 */
	function display_mainpage($args = array(), $msg = ''){	
	?>
	<div class="wrap">
		<h2><?php echo PR_TITLE; ?></h2>
		<?php
		if($msg != '')
			echo '<div id="message" class="updated below-h2"><p>' . $msg . '</p></div>';
		?>
		<form class="pr-form" name="" method="post">
			<p><label for="pr-pages"><?php echo PR_PAGES; ?></label></p>			
			<?php echo PRViews::pages_menu($args['pr_pages']); ?>
			<p>
				<input name="pr_type" id="pr-type" value="page-refresh" type="radio" <?php echo ($args['pr_type'] == 'page-refresh') ? 'checked="checked"' : '' ?>><label><?php echo PR_PAGEREFRESH; ?></label> 				
			<p>			
			<p>
				<input name="pr_type" id="pr-type" value="time-limit" type="radio" <?php echo ($args['pr_type'] == 'time-limit') ? 'checked="checked"' : '' ?>><label><?php echo PR_TIMELIMIT; ?></label> 
				<input class="pr_small_fld" type="text" name="pr_min" id="pr-min" value="<?php echo $args['pr_min']; ?>"> to 
				<input class="pr_small_fld" type="text" name="pr_max" id="pr-max" value="<?php echo $args['pr_max']; ?>"><em><?php echo PR_MINUTES; ?></em></p>
			<p>
				<input name="pr_type" id="pr-type" value="per-visit" type="radio" <?php echo ($args['pr_type'] == 'per-visit') ? 'checked="checked"' : '' ?>><label><?php echo PR_PERVISIT; ?></label> 
				<input class="pr_small_fld" type="text" name="pr_cookielife" id="pr-cookielife" value="<?php echo $args['pr_cookielife']; ?>"><em><?php echo PR_MINUTES; ?></em></p>	
			<p>
				<label for="pr"><?php echo PR_ROTSEQ; ?></label>
				<select name="pr_sequence" id="pr-sequence">
					<option value="order" <?php echo ($args['pr_sequence'] == 'order') ? 'selected="selected"' : ''; ?>><?php echo PR_ORDER; ?></option>
					<option value="random" <?php echo ($args['pr_sequence'] == 'random') ? 'selected="selected"' : ''; ?>><?php echo PR_RANDOM; ?></option>
				</select>				
			</p>
			<div class="submit">
				<input type="submit" class="button-primary" value="Save Changes" />
			</div>			
		</form>
	</div>
	<?php
	}
	
	/**
	 * based on Wordpress' wp_dropdown_pages();
	 * display a multiple select drop down of wordpress pages
	 */
	static function pages_menu($arr = array()){
		$defaults = array(
			'depth' => 0, 'child_of' => 0,
			'selected' => 0, 'echo' => 1,
			'name' => 'page_id', 'id' => '',
			'show_option_none' => '', 'show_option_no_change' => '',
			'option_none_value' => ''
		);

		$r = wp_parse_args( $args, $defaults );
		extract( $r, EXTR_SKIP );

		$pages = get_pages($r);
		echo '<select name="pr_pages[]" multiple="multiple" id="pr-pages">';		
		foreach($pages as $p){
			$selected = (in_array($p->ID, $arr)) ? ' selected="selected"' : '';
			echo '<option name="" value="' . $p->ID . '"' . $selected . '>' . $p->post_title . '</option>';
		}
		echo '</select>';
	}
	/**
	 * displays the news page
	 */
	function display_news(){
	$plugin_news_page = 'http://www.plugingreat.com/plugin-news/news-rotating-page.php';
	?>
		<div class="wrap">
			<h2><?php echo PR_NEWS; ?></h2>
			<?php
				$pluginnews = wp_remote_post($plugin_news_page, array('timeout' => 60));
				$globalnews = wp_remote_post('http://www.plugingreat.com/plugin-news/news-global-plugins.php', array('timeout' => 60));
				
				echo $pluginnews['body'];
				echo $globalnews['body'];
			?>				
		</div>
	<?php
	}
}
?>