<?php
/*
Plugin Name: Rotation Genie
Plugin URI: http://onlinesuccesswithchris.com/
Version: 2.1.0
Author: Chris Jenkins
Author URI: http://onlinesuccesswithchris.com/
Description: Product Genie is a Wordpress Plugin used to rotate opt-in pages on a given WordPress site. This is copyrighted software. Modification is allow with MRR purchase. Redistribution is only permitted with a purchased licensing agreement from the author. | <a href="../wp-content/plugins/rotationgenie/rotationgenie-readme.txt">ReadMe</a> | <a href="../wp-content/plugins/rotationgenie/rotationgenie-docs.pdf">User Manual</a> | 
*/

include_once('includes/view.php');
include_once('includes/lang_en.php');

define('PR_BASEPATH', str_replace('\\', '/', WP_PLUGIN_DIR . '/' . basename(dirname(__FILE__)) . '/'));
define('PR_BASEURL', str_replace('\\', '/', WP_PLUGIN_URL . '/' . basename(dirname(__FILE__)) . '/'));
define('PR_AJAXURL', GP_BASEURL . '/includes/ajax.php');
define('PR_MAINSLUG', 'page-rotate');

wp_enqueue_script('pr-script', PR_BASEURL . '/scripts/functions.js');
wp_enqueue_style('pr-style', PR_BASEURL . '/styles/style.css');


add_action('admin_menu', 'pr_menu');

function pr_menu(){
	$v = new PRViews();
	add_menu_page(PR_TITLE, PR_TITLE, 'administrator', PR_MAINSLUG, 'pr_main_page', PR_BASEURL . 'images/pg-logo.png');
/*	add_submenu_page(PR_MAINSLUG, PR_NEWS, PR_NEWS, 'administrator', 'pr-news', array($v, 'display_news'));*/
/*	add_submenu_page(PR_MAINSLUG, 'administrator');*/
}

add_action('plugins_loaded', 'pr_init');

function pr_init(){	
	update_option('show_on_front', 'page');

	$data = get_option('rotate_pages');
	$pages = $data['pages'];
	$type = $data['type'];
	$sequence = $data['sequence'];
	
	$front_page = 'page' == get_option('show_on_front') ? (int) get_option( 'page_on_front' ) : 0;

	$cur_time = time();
	if($type == 'page-refresh'){
		$new_frontpage = pr_getnextpage($pages, $front_page, $sequence);			
		if($front_page != $new_frontpage)
			update_option('page_on_front', $new_frontpage);
	}	
	if($type == 'time-limit'){
		$max = $data['max'];
		$min = $data['min'];	
		$i = get_option('rotate_pages_current');
		if($cur_time > $i['end']){
			$new_frontpage = pr_getnextpage($pages, $front_page, $sequence);			
			$minutes = rand(intval($min), intval($max));
			$info['page'] = $new_frontpage;
			$info['start'] = $cur_time;
			$info['end'] = $cur_time + ($minutes * 60);
			update_option('rotate_pages_current', $info);
			if($front_page != $new_frontpage)
				update_option('page_on_front', $new_frontpage);
		}
	}
	else if($type == 'per-visit'){
		$clife = $data['cookielife'];		
		$i = get_option('rotate_pages_current');

		$cookie_curpage = $_COOKIE['rotate-page-current'];
		if($clife != '' && $clife != 0){
			if($cookie_curpage == '' || !pr_isvalidpage($cookie_curpage)){				
				$x =  $cur_time + (60 * $clife);
				$new_frontpage = pr_getnextpage($pages, $front_page, $sequence);
				setcookie("rotate-page-current", $new_frontpage, $x, "/");
				echo  $_COOKIE['rotate-page-current'];
				if($front_page != $new_frontpage)
					update_option('page_on_front', $new_frontpage);
			}
			else{
				if($front_page != $cookie_curpage)
					update_option('page_on_front', $cookie_curpage);
			}
		}
		else{
			$new_frontpage = pr_getnextpage($pages, $front_page, $sequence);
			if($front_page != $new_frontpage){
				update_option('page_on_front', $new_frontpage);			
			}
		}
	}	
}

function pr_isvalidpage($pid){
	$opt = get_option('rotate_pages');
	$pages = $opt['pages'];
	if(in_array($pid, $pages)){
		return true;
	}
	return false;
}
function pr_getnextpage($pages, $front_page, $sequence = 'order'){
	$next = false;
	if($sequence == 'order'){		
		foreach($pages as $p){
			if($next == true){
				return $p;
				break;
			}
			if($p == $front_page){
				$next = true;
			}
		}
	}
	else if($sequence == 'random'){
		$count = count($pages);
		$r = rand(0, $count - 1);
		return $pages[$r];
	}
	
	return $pages[0];
}
function pr_main_page(){
	$sub = $_GET['subpage'];
	switch($sub){
		default:
			$p = null;
			if(is_array($_POST['pr_pages'])){
				$p['pages'] = $_POST['pr_pages'];
				$p['type'] = $_POST['pr_type']; //time-limit or visit
				$p['max'] = intval($_POST['pr_max']);
				$p['min'] = intval($_POST['pr_min']);
				$p['cookielife'] = intval($_POST['pr_cookielife']);
				$p['sequence'] = $_POST['pr_sequence'];
				$msg = PR_CHANGESSAVED;
				update_option('rotate_pages', $p);
			}
			else{
				$data = get_option('rotate_pages');
				$_POST['pr_pages'] = $data['pages'];
				$_POST['pr_type'] = $data['type'];
				$_POST['pr_max'] = $data['max'];
				$_POST['pr_min'] = $data['min'];
				$_POST['pr_cookielife'] = $data['cookielife'];
				$_POST['pr_sequence'] = $data['sequence'];
			}
			
			PRViews::display_mainpage($_POST, $msg);
	}
}

?>